const path = require('path')
const pxtovw = require('postcss-px-to-viewport')
const publicPath = '/wj-data-vision-new'
const port = 9300
const CompressionWebpackPlugin = require('compression-webpack-plugin')
const productionGzipExtensions = ['js', 'css']
const proxy = {
  '/sso': {
    target: 'http://10.102.1.182:9000',
  },
  '/holo': {
    target: 'http://10.102.1.182:9000',
  },
  '/web': {
    target: 'http://10.102.1.182:9000',
  },
  '/design': {
    target: 'http://10.102.1.182:9000',
  },
  '/develop': {
    target: 'http://10.102.1.182:9000',
  },
  '/opt': {
    target: 'http://10.102.1.182:9000',
  },
  '/cdn': {
    target: 'http://127.0.0.1:3000',
  },
}

module.exports = {
  publicPath,
  outputDir: 'dist',
  assetsDir: 'static',
  productionSourceMap: true,
  devServer: {
    port,
    overlay: {
      warnings: false,
      errors: true,
    },
    proxy,
  },
  css: {
    loaderOptions: {
      postcss: {
        //给postcss-loader传递选项
        plugins: [
          new pxtovw({
            unitToConvert: 'px', //需要转换的单位，默认为"px"；
            viewportWidth: 3840, //设计稿的视口宽度
            unitPrecision: 5, //单位转换后保留的小数位数
            propList: ['*'], //要进行转换的属性列表,*表示匹配所有,!表示不转换
            viewportUnit: 'vw', //转换后的视口单位
            fontViewportUnit: 'vw', //转换后字体使用的视口单位
            selectorBlackList: [], //不进行转换的css选择器，继续使用原有单位
            minPixelValue: 1, //设置最小的转换数值
            mediaQuery: false, //设置媒体查询里的单位是否需要转换单位
            replace: true, //是否直接更换属性值，而不添加备用属性
            exclude: [/node_modules/], //忽略某些文件夹下的文件
          }),
        ],
      },
    },
  },
  configureWebpack: {
    resolve: {
      alias: {
        vue$: 'vue/dist/vue.esm.js',
        '@': path.join(__dirname, 'src'),
      },
    },
    plugins: [
      new CompressionWebpackPlugin({
        algorithm: 'gzip',
        test: new RegExp('\\.(' + productionGzipExtensions.join('|') + ')$'),
        threshold: 10240,
        minRatio: 0.8,
      }),
    ],
  },
}
